Random123-1.09: r123::ARS1xm128i_R< ROUNDS > Class Template Reference

- Random123-1.09 Documentation

Public Types | Public Member Functions | Static Public Attributes

# r123::ARS1xm128i_R< ROUNDS > Class Template Reference
[ARS and AESNI Classes and Typedefs]

`#include <Random123/ars.h>`

List of all members.

## Public Types
typedef ars1xm128i_ctr_t | ctr_type
typedef ars1xm128i_key_t | key_type
typedef ars1xm128i_key_t | ukey_type
## Public Member Functions
ctr_type | operator() (ctr_type ctr, key_type key) const
## Static Public Attributes
static const unsigned int | rounds = ROUNDS

## Detailed Description

### template<unsigned int ROUNDS>
class r123::ARS1xm128i_R< ROUNDS >

ARS1xm128i_R exports the member functions, typedefs and operator overloads required by a Counter Based RNGs (CBRNGs). class.

ARS1xm128i uses the crypotgraphic AES round function, but a non-cryptographc key schedule to save time and space.

ARS1xm128i is only available when the feature-test macro R123_USE_AES_NI is true, which should occur only when the compiler is configured to generate AES-NI instructions (or when defaults are overridden by compile-time, compiler-command-line options).

The template argument, ROUNDS, is the number of times the ARS round functions will be applied.

As of September 2011, the authors know of no statistical flaws with ROUNDS=5 or more.

ARS1xm128i is equivalent to ARS1xm128i_R<7>. With 7 rounds, the ARS1xm128i CBRNG has a considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has excellent performance.

## Member Typedef Documentation

template<unsigned int ROUNDS>

typedef ars1xm128i_ctr_t r123::ARS1xm128i_R< ROUNDS >::ctr_type

template<unsigned int ROUNDS>

typedef ars1xm128i_key_t r123::ARS1xm128i_R< ROUNDS >::key_type

template<unsigned int ROUNDS>

typedef ars1xm128i_key_t r123::ARS1xm128i_R< ROUNDS >::ukey_type

## Member Function Documentation

template<unsigned int ROUNDS>

ctr_type r123::ARS1xm128i_R< ROUNDS >::operator() | ( | ctr_type | ctr,
|  | key_type | key |
| ) |  |  | const`[inline]`

## Member Data Documentation

template<unsigned int ROUNDS>

const unsigned int r123::ARS1xm128i_R< ROUNDS >::rounds = ROUNDS`[static]`

The documentation for this class was generated from the following file:

- Random123/ars.h

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines